/* mbed Microcontroller Library
 * Copyright (c) 2019 ARM Limited
 * SPDX-License-Identifier: Apache-2.0
 */

#include "mbed.h"
#include "platform/mbed_thread.h"

// Blinking rate in milliseconds
#define BLINKING_RATE_MS_SLOW                             1500
#define BLINKING_RATE_MS_FAST                              100

void GPIO_Init(void)
{
  GPIO_InitTypeDef GPIO_InitStruct = {0};

  __HAL_RCC_GPIOA_CLK_ENABLE();
  GPIO_InitStruct.Pin = GPIO_PIN_0;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(GPIOA, &GPIO_InitStruct);
}

int main()
{
    HAL_Init();
    GPIO_Init();
    // Initialise the digital pin LED1 as an output
    DigitalOut led1(LED1);
    DigitalIn  btn1(USER_BUTTON);

    while (true) {
        led1 = !led1;
        if (btn1==0) {  // button is pressed
            HAL_GPIO_WritePin(GPIOA, GPIO_PIN_0, GPIO_PIN_SET);  // LEDを点灯
            thread_sleep_for(BLINKING_RATE_MS_FAST);
        } else {
            HAL_GPIO_WritePin(GPIOA, GPIO_PIN_0, GPIO_PIN_RESET);  // LEDを消灯
            thread_sleep_for(BLINKING_RATE_MS_SLOW);
        }
    }
}
